/*
 * getopt.h
 *
 * By Ross Ridge
 * Public Domain
 *
 * Defines the class getopt.
 *
 * @(#) MySC getopt.h 1.4 97/12/29 20:27:15
 *
 */

#ifndef __GETOPT_H__
#define __GETOPT_H__

class getopt {
public:
	enum { 
		END_OF_ARGUMENTS = 0,
		UNRECOGNIZED_OPTION = -1,
		MISSING_ARGUMENT = -2
	};

private:
	int argc;
	char **argv;

	int index;
	char *cindex;
	char const *opts;
	int opterr;
	char *arg;

	static int is_optional(char c);
	static int is_required(char c);

public:
	getopt(int ac, char **av, char const *s, int err = 1)
		: argc(ac), argv(av), index(1), cindex(NULL), 
	          opts(s), opterr(err) {}
	int next();

	int get_index() { return index; }
	char *getarg() { return arg; }
};

#endif /* __GETOPT_H__ */

/* Local variables: */
/* mode: c++ */
/* End: */
