/*
 * list.c
 *
 * By Ross Ridge 
 * Public Domain
 *
 * Member functions of the template list.
 *
 * @(#) MySC list.c 1.5 98/04/12 20:00:18
 *
 */

#ifndef __LIST_C__
#define __LIST_C__

template <class TYPE>
void
list<TYPE>::destroy() {
	if (len != 0) {
		delete[] array;
	}
}

template <class TYPE>
void
list<TYPE>::copy(list<TYPE> const &l) {
  	len = l.len;
	left = 0;
	if (len > 0) {
		array = new TYPE[len];
		int i;
		for(i = 0; i < len; i++) {
			array[i] = l.array[i];
		}
	}
}

template <class TYPE>
list<TYPE> &
list<TYPE>::operator =(list<TYPE> const &l) {
	if (this != &l) {
		destroy();
		copy(l);
	}
	return *this;
}
	
template <class TYPE>
void
list<TYPE>::grow(int new_left, int offset) {
#if 0
	printf("@@@: %d %p new_left %d, left %d, len %d\n",
	       sizeof(TYPE), (void *) this,
	       new_left, left, len);
#endif
	if (new_left < 4) {
		new_left = 4;
	}

	TYPE *new_array = new TYPE[len + new_left];
	left = new_left;
	if (len != 0) {
		int i;
		for(i = 0; i < len; i++) {
			new_array[i + offset] = array[i];
		}
		delete[] array;
	}
	array = new_array;
}

template <class TYPE>
int
list<TYPE>::add(TYPE const &ent) {
	if (left == 0) {
		grow(len);
	}
	array[len++] = ent;
	left--;
	return 0;
}

#if 0
template <class TYPE>
auto_free_list<TYPE>::~auto_free_list() {
	int i;
	for (i = 0; i < len; i++) {
		TYPE p = array[i];
		if (p != NULL) {
			free(p);
		}
	}
}
#endif

#endif /* __LIST_C__ */

/* Local variables: */
/* mode: c++ */
/* End: */
