/*
 * run.h
 *
 * By Ross Ridge
 * Public Domain
 *
 * @(#) MySC run.h 1.3 98/06/06 16:25:57
 *
 */

#ifndef __RUN_H__
#define __RUN_H__

#include "list.h"

#ifdef CONFIG_NO_FORK

#if defined(CONFIG_NO_SPAWN) && !defined(CONFIG_DJGPP)

#define STATUS(n) (0)
#define STATUS_MSG(n) 

#else /* defined(CONFIG_NO_SPAWN) && !defined(CONFIG_DJGPP) */

#define STATUS(n) (n)
#define STATUS_MSG(n) (n)

#endif /* defined(CONFIG_NO_SPAWN) && !defined(CONFIG_DJGPP) */

#else /* CONFIG_NO_FORK */

#define STATUS(n) ((n) << 8)
#define STATUS_MSG(n) (((unsigned) (n)) >> 8)

#endif /* CONFIG_NO_FORK */

int run(char const *prg, list<string> const &args);
int run_mr_checker(char const *prg, char const *arg1,
		   list<string> mrs);

#endif /* __RUN_H__ */

/* Local variables: */
/* mode: c++ */
/* End: */
