/*
 * sf-bseqt.c 
 *
 * By Ross Ridge
 * Public Domain
 *
 * The sccs_file::_delta_table::build_seq_table member function used in 
 * sccs_file::_delta_table::operator[] inline member function.
 * 
 */

#include "mysc.h"
#include "sccsfile.h"

#ifdef CONFIG_SCCS_IDS
static char const sccs_id[] = "@(#) MySC sf-bseqt.c 1.1 98/04/11 14:21:43";
#endif

/*
 * Build a maping table of sequence numbers to entries in the delta
 * table when needed.
 */

int
sccs_file::_delta_table::build_seq_table() {
	seq_table = (int *) xmalloc((high_seqno + 1) * sizeof(int));

	int i;
	for(i = 0; i < high_seqno + 1; i++) {
		seq_table[i] = -1;
	}

	delta_iterator iter(*this);
	while(iter.next(1)) {
		seq_no seq = iter->seq;
		if (seq_table[seq] != -1) {
			error(msgptr(85, "Sequence number %u is duplicated"
				     " in delta table."), seq);
			return -1;
		}
		seq_table[seq] = iter.index();
	}
	return 0;
}


