/*
 * sf-cdc.c
 *
 * By Ross Ridge
 * Public Domain
 *
 * Members of the class sccs_file used for change the comments and
 * MRs of a delta. 
 *
 */

#include "mysc.h"
#include "sccsfile.h"

#ifdef CONFIG_SCCS_IDS
static char const sccs_id[] = "@(#) MySC sf-cdc.c 1.3 98/01/06 08:24:51";
#endif

/* Adds new MRs and comments to the specified delta. */

int
sccs_file::cdc(sid id, list<string> mrs, list<string> comments) {
	int i;
	int len;

	struct delta *p = (struct delta *) delta_table.find(id); /* !!! */
	if (p == NULL) {
		error(msgptr(120, "%s: Requested SID doesn't exist."),
		      (char const *) name);
		return -1;
	}
	struct delta &delta = *p;

	list<string> not_mrs;
	len = mrs.length();
	for(i = 0; i < len; i++) {
		char const *s = mrs[i];
		if (s[0] == '!') {
			not_mrs.add(s + 1);
		} else {
			delta.mrs.add(s);
		}
	}

	delta.mrs -= not_mrs;

	delta.comments += comments;

	return 0;
}

/* Local variables: */
/* mode: c++ */
/* End: */
